mostly profanity and fixes
[distro-setup] / switch-mail-host
index f7d926c39b84481b0834f4a3a72e8f85280218c5..3a362c3b5ace6bc2409d8226c75e684b459c5a1c 100644 (file)
@@ -104,7 +104,7 @@ if [[ ! $HOSTNAME ]]; then
 fi
 
 uninstalled-file-die() {
-  die "uninstalled file $1. run install-my-scripts or rerun with -f"
+  die "on host=$HOSTNAME, uninstalled file $1. run install-my-scripts or rerun with -f"
 }
 
 
@@ -154,17 +154,12 @@ case $direction in
     bbk_args="-s $old_host"
     old_shell="ssh -F $HOME/.ssh/confighome root@$old_host"
     # tests ssh connection. crafted this to not need to do escape chars
-    f=/a/bin/bash_unpublished/source-state
-    if ! old_info=$($old_shell "hostname; sed -n s,.*MAIL_HOST=,,p $f; sed -n s,.*HOST2=,,p $f"); then
-      echo "$pre: error: failed ssh. retrying failed $old_shell with -v for more info:"
-      $old_shell -v hostname
-      exit 1
-    fi
-    IFS=" " read -r old_hostname MAIL_HOST HOST2 <<<"$old_info"
 
     if ! $mail_only && ! $pull_reexec ; then
       if ! $force; then
-        $old_shell switch-mail-host --check-installed
+        if ! $old_shell switch-mail-host --check-installed; then
+          die "failed: $old_shell switch-mail-host --check-installed"
+        fi
       fi
       tmpf=$(mktemp)
       m scp -F $HOME/.ssh/confighome root@$old_host:/usr/local/bin/switch-mail-host $tmpf
@@ -176,6 +171,14 @@ case $direction in
       fi
     fi
 
+    f=/a/bin/bash_unpublished/source-state
+    if ! old_info=$($old_shell "hostname; sed -n s,.*MAIL_HOST=,,p $f; sed -n s,.*HOST2=,,p $f"); then
+      echo "$pre: error: failed ssh. retrying failed $old_shell with -v for more info:"
+      $old_shell -v hostname
+      exit 1
+    fi
+    read -d '' -r old_hostname MAIL_HOST HOST2 <<<"$old_info" || (( $? == 1 ))
+
     ;;
   *)
     err invalid first argument
@@ -278,7 +281,9 @@ EOF
   fi
 } | $new_shell bash -s
 
-$old_shell bash -s <<'EOF'
+if ! $mail_only; then
+  $old_shell bash -s <<'EOF'
+set -e
 if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
   bufs="$(sudo -u iank env XDG_RUNTIME_DIR=/run/user/1000 emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
   if [[ $bufs ]]; then
@@ -286,7 +291,16 @@ if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
     exit 1
   fi
 fi
+
+# Try to prevent emacs from saving stale data it has in memory to disk. eg: files, recentf list, etc.
+# But if emacs ignores the signal, let it live.
+killall -q emacs ||:
+
+if [[ -e /p/profanity-here ]]; then
+  systemctl disable --now profanity
+fi
 EOF
+fi
 
 # previously, I was checking to see if the new mail host
 # is on my home network, then changing my home dns
@@ -320,6 +334,9 @@ if $host2_only; then
     m $old_shell systemctl --now disable btrbk.timer
   fi
   m $new_shell systemctl --now enable btrbk.timer
+  if [[ -e /p/profanity-here ]]; then
+    m $new_shell systemctl --now enable profanity
+  fi
   exit 0
 fi
 
@@ -329,9 +346,6 @@ if (( ret )); then
   exit $ret
 fi
 
-# Try to prevent emacs from saving stale data it has in memory to disk. eg: files, recentf list, etc.
-# But if emacs ignores the signal, let it live.
-m $new_shell killall -q emacs ||:
 
 e Running main btrbk
 m btrbk-run -v --fast $bbk_args $force_arg $incremental_arg -m /o || ret=$?
@@ -343,8 +357,8 @@ if (( ret )); then
 fi
 
 # new system is usable at this point
-printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s $(eval echo "{1..${COLUMNS:-60}}")"
-echo
+blocks=██████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
+printf "%s\n" "$(tput setaf 5 2>/dev/null ||:)${blocks:0:${COLUMNS:-180}}$(tput sgr0 2>/dev/null||:)"
 
 # once I accidentally accepted incoming mail on old host. I used this script to copy over that mail:
 #
@@ -360,4 +374,12 @@ if (( ret )); then
   exit $ret
 fi
 
+if ! $mail_only && [[ -e /p/profanity-here ]]; then
+  m $new_shell systemctl --now enable profanity || ret=$?
+  if (( ret )); then
+    err "failed final systemctl --now enable profanity, just fix and rerun"
+    exit $ret
+  fi
+fi
+
 m exit 0